# mypy-boto3-auditmanager

[![PyPI - mypy-boto3-auditmanager](https://img.shields.io/pypi/v/mypy-boto3-auditmanager.svg?color=blue)](https://pypi.org/project/mypy-boto3-auditmanager)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-auditmanager.svg?color=blue)](https://pypi.org/project/mypy-boto3-auditmanager)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.AuditManager 1.17.3](https://boto3.amazonaws.com/v1/documentation/api/1.17.3/reference/services/auditmanager.html#AuditManager) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.4.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-auditmanager](#mypy-boto3-auditmanager)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `AuditManager` service.

```bash
python -m pip install boto3-stubs[auditmanager]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[auditmanager]` in your environment: `python -m pip install 'boto3-stubs[auditmanager]'`

Both type checking and auto-complete should work for `AuditManager` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[auditmanager]` in your environment: `python -m pip install 'boto3-stubs[auditmanager]'`

Both type checking and auto-complete should work for `AuditManager` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[auditmanager]` in your environment: `python -m pip install 'boto3-stubs[auditmanager]'`
- Run `mypy` as usual

Type checking should work for `AuditManager` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[auditmanager]` in your environment: `python -m pip install 'boto3-stubs[auditmanager]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `AuditManager` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`AuditManagerClient` provides annotations for `boto3.client("auditmanager")`.

```python
import boto3

from mypy_boto3_auditmanager import AuditManagerClient

client: AuditManagerClient = boto3.client("auditmanager")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AuditManagerClient = session.client("auditmanager")
```








### Typed dictionations

`mypy_boto3_auditmanager.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_auditmanager.type_defs import (
    AWSAccountTypeDef,
    AWSServiceTypeDef,
    AssessmentControlSetTypeDef,
    AssessmentControlTypeDef,
    AssessmentEvidenceFolderTypeDef,
    AssessmentFrameworkMetadataTypeDef,
    AssessmentFrameworkTypeDef,
    AssessmentMetadataItemTypeDef,
    AssessmentMetadataTypeDef,
    AssessmentReportEvidenceErrorTypeDef,
    AssessmentReportMetadataTypeDef,
    AssessmentReportTypeDef,
    AssessmentReportsDestinationTypeDef,
    AssessmentTypeDef,
    BatchCreateDelegationByAssessmentErrorTypeDef,
    BatchDeleteDelegationByAssessmentErrorTypeDef,
    BatchImportEvidenceToAssessmentControlErrorTypeDef,
    ChangeLogTypeDef,
    ControlCommentTypeDef,
    ControlMappingSourceTypeDef,
    ControlMetadataTypeDef,
    ControlSetTypeDef,
    ControlTypeDef,
    CreateAssessmentFrameworkControlTypeDef,
    CreateDelegationRequestTypeDef,
    DelegationMetadataTypeDef,
    DelegationTypeDef,
    EvidenceTypeDef,
    FrameworkMetadataTypeDef,
    FrameworkTypeDef,
    ManualEvidenceTypeDef,
    NotificationTypeDef,
    ResourceTypeDef,
    RoleTypeDef,
    ScopeTypeDef,
    ServiceMetadataTypeDef,
    SettingsTypeDef,
    SourceKeywordTypeDef,
    URLTypeDef,
    BatchAssociateAssessmentReportEvidenceResponseTypeDef,
    BatchCreateDelegationByAssessmentResponseTypeDef,
    BatchDeleteDelegationByAssessmentResponseTypeDef,
    BatchDisassociateAssessmentReportEvidenceResponseTypeDef,
    BatchImportEvidenceToAssessmentControlResponseTypeDef,
    CreateAssessmentFrameworkControlSetTypeDef,
    CreateAssessmentFrameworkResponseTypeDef,
    CreateAssessmentReportResponseTypeDef,
    CreateAssessmentResponseTypeDef,
    CreateControlMappingSourceTypeDef,
    CreateControlResponseTypeDef,
    DeregisterAccountResponseTypeDef,
    GetAccountStatusResponseTypeDef,
    GetAssessmentFrameworkResponseTypeDef,
    GetAssessmentReportUrlResponseTypeDef,
    GetAssessmentResponseTypeDef,
    GetChangeLogsResponseTypeDef,
    GetControlResponseTypeDef,
    GetDelegationsResponseTypeDef,
    GetEvidenceByEvidenceFolderResponseTypeDef,
    GetEvidenceFolderResponseTypeDef,
    GetEvidenceFoldersByAssessmentControlResponseTypeDef,
    GetEvidenceFoldersByAssessmentResponseTypeDef,
    GetEvidenceResponseTypeDef,
    GetOrganizationAdminAccountResponseTypeDef,
    GetServicesInScopeResponseTypeDef,
    GetSettingsResponseTypeDef,
    ListAssessmentFrameworksResponseTypeDef,
    ListAssessmentReportsResponseTypeDef,
    ListAssessmentsResponseTypeDef,
    ListControlsResponseTypeDef,
    ListKeywordsForDataSourceResponseTypeDef,
    ListNotificationsResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    RegisterAccountResponseTypeDef,
    RegisterOrganizationAdminAccountResponseTypeDef,
    UpdateAssessmentControlResponseTypeDef,
    UpdateAssessmentControlSetStatusResponseTypeDef,
    UpdateAssessmentFrameworkControlSetTypeDef,
    UpdateAssessmentFrameworkResponseTypeDef,
    UpdateAssessmentResponseTypeDef,
    UpdateAssessmentStatusResponseTypeDef,
    UpdateControlResponseTypeDef,
    UpdateSettingsResponseTypeDef,
    ValidateAssessmentReportIntegrityResponseTypeDef,
)

def get_structure() -> AWSAccountTypeDef:
    return {
      ...
    }
```
